# CommentConverter 0.4.2 Docs

This document tries to describe what has been done and how everything works so far. I'll try to keep it short and hopefully I
won't repeat myself too much. It's probably not complete but most of the important things should be here and already mentioned
in the post I uploaded this with.

For short usage examples refer to [Usage](./Usage.md).

## Current report from user side

### Dependencies

- requests

### What works

- We can convert comments to html
- Replies can be shown and hidden using button if JS is enabled
- We have some kind of youtube-style look
- We have links to user channels (linking directly from name for now)
- Replies are sorted __and__ chained correctly unlike in prev version
- Debug info included (some replies are broken by youtube and the debug should help to detect if its mine fuckup or youtubes)
- There should be some backwards compatibility for parsing old comments without certain things (avatars, channel links)
- We have comments per page limit, this is just roughly the number of comments per page because we are not counting replies as
  full comments. So the resulting number will be probably higher, but should be manageble
- We have working avatar downloading, it's not the fastest and the estimate is probably the least accurate estimation ever but it
  works!
- If original avatar is 404 we copy the default "avatar.jpg" included or your own

### Whats broken/not implemented

- The "Show more" button is not implemented (we should do that eventually, people use it for dramatic effects quite a lot)
- __ONLY__ scrapped comments are supported at the moment as they are much easier to work with
- The button is permanently shown for now, later it should be remade to be also created with javascript so it won't even display
  without it
- __No checks are done__ for existence of any files except input! When linking resources (video, css, js) use the path that should
  be used when the html will be opened (relative).
- We are using non-html5 format because otherwise there is no (known to me) way how to make iframe take entirepage, everyone says
  this is a bad thing so we should probably fix this somehow

### Assumptions this script makes

- requests are installed
- Python3 is used
- Assets bundled with this script are to be in the same location as script, this allows for copying them to any dir you may
  execute this script from. Not keeping this results in warning

### Nearest ToDos:

- Color current comment page you are on
- Make default avatar _not_ hardcoded
- Make counter of 404'd avatars? pretty useless but it would be nice stats
- Make waiting before avatar downloads more dynamic to speed it up and check for more specific errors if google gets angry
- ScrappedComment & APIcomment -> UniversalJSON
- API comment support
- TOML? Configuration file for better automation
- Show more functionality in comments (we need to figure out how it works first)

### More features ideas

- Add static linking? (expand css and js to their <tags>)?, we could technically include images like this as well

## Current report from back-end side

### What is where and what is what

This part mainly desribes what is being done where and how; if something was to be changed. It's not really important if _(you)_ are
not planing to change anything

#### convert.py

Converting logic - generates html file. Converter itself works as configuration class with defaults. First all properties are set
in _CommentConverter_ and then the ``export()`` function does the actuall writing.

Currently two methods supported, the pagged one and unpaged one, they work different now because of ``<iframe>`` usage so not sure
if we should merge them.


#### commentModels.py

- Contains all supported comment models
- In the future should contain ``ScrappedComment``, ``Apicomment`` and ``UniversalComment`` the last one being the one we will be working with

#### CommentConverter.py

- Entry point
- Args parsing
- JSON parsing

#### script.js

very creative name I know.

- All of the js for expanding and shrinking of comment replies
- Comment html must be completely usable without JS so anything interactive must be initialized to it's "Initial" (hidden) form here
  (shrinking comments chains instead of exporting them shrinked already)
- ``autoLoad()`` Is called when ``<body>`` is loaded because i don't know how else to run on load directly (document.onLoad()
  somehow didn't worked for me from the JS), might be good idea to move it to the ``script.js`` completely

#### style.css

Well It's better than nothing chaining. Currently unordered list is used for chaining replies as there will always be max 1 level
of indent.

For more info about classes - reading ``converter.py:writeComments()``, ``converter.py:writeSingleComment()`` and ``style.css`` is
encuradged. I tried to make the CSS class names sound as logical as I could, however I never really worked with CSS much before so I
may have used some weird combinations or names.

Logic is mostly that everything that somehow belongs to comment has ``comment-`` prefix and it goes from there. For more info
check out ``style.css``

#### Utils.py

- Generic utils, it's avatar and file downloading now.
- Probably not very reusable yet, may need some improvements

## What to do next

These are just few suggestions for what should have the highest priotity right now.

### To implement

- Convertor - relative to absolute date
  - Hopefully there exists some program that does this already (doesn't seem so, so far)
  - Will be huge cluster fuck
  - Must support the language comments were scrapped in
  - Accuracy will be shit but the worst case should 1/2 year if I am correct (assuming file creation date won't be changed anywhere)
  - We'll probably have to use file creation date as the it's the only other "relative" time point we have

### To figure out

Things that need to be figured out:

- How to do the actuall archiving - as we are mostly using other programs (youtube-dl, comment scrapper, ffmpeg..) we should
  probably figure out some really good way of gluing it together to be able to make it highly automatized.
- Figure out the scope of this particular _script?_ - Should we also "pack it" here? generate dir structure here? just convert
  comments and exit (making new program for the rest)?
- Directory structure for this script? It's probably not the best idea to dump everything in one dir, maybe the default scripts or
  styles should be in some ``default/`` dir or something
